Index: trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/radii_mod.F90	(revision 787)
@@ -20,5 +20,5 @@
 
 !==================================================================
-   subroutine su_aer_radii(reffrad,nueffrad)
+   subroutine su_aer_radii(ngrid,reffrad,nueffrad)
 !==================================================================
 !     Purpose
@@ -35,13 +35,15 @@
       use radinc_h, only: naerkind
       use aerosol_mod
-      Implicit none
-
-#include "callkeys.h"
-#include "dimensions.h"
-#include "dimphys.h"
-#include "tracer.h"
-
-      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
-      real, intent(inout) :: nueffrad(ngridmx,nlayermx,naerkind)     !variance     
+      USE tracer_h
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
+
+      integer :: ngrid
+
+      real, intent(inout) :: reffrad(ngrid,nlayermx,naerkind)      !aerosols radii (K)
+      real, intent(inout) :: nueffrad(ngrid,nlayermx,naerkind)     !variance     
 
       logical, save :: firstcall=.true.
@@ -56,21 +58,21 @@
 
             if(iaer.eq.iaero_co2)then ! CO2 ice
-               reffrad(1:ngridmx,1:nlayermx,iaer) = 1.e-4
-               nueffrad(1:ngridmx,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayermx,iaer) = 1.e-4
+               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
             endif
 
             if(iaer.eq.iaero_h2o)then ! H2O ice
-               reffrad(1:ngridmx,1:nlayermx,iaer) = 1.e-5
-               nueffrad(1:ngridmx,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayermx,iaer) = 1.e-5
+               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
             endif
 
             if(iaer.eq.iaero_dust)then ! dust
-               reffrad(1:ngridmx,1:nlayermx,iaer) = 1.e-5
-               nueffrad(1:ngridmx,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayermx,iaer) = 1.e-5
+               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
             endif
  
             if(iaer.eq.iaero_h2so4)then ! H2O ice
-               reffrad(1:ngridmx,1:nlayermx,iaer) = 1.e-6
-               nueffrad(1:ngridmx,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayermx,iaer) = 1.e-6
+               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
             endif
 
@@ -117,5 +119,5 @@
 
 !==================================================================
-   subroutine h2o_reffrad(pq,pt,reffrad,nueffrad)
+   subroutine h2o_reffrad(ngrid,nq,pq,pt,reffrad,nueffrad)
 !==================================================================
 !     Purpose
@@ -131,16 +133,18 @@
       use watercommon_h, Only: T_h2O_ice_liq,T_h2O_ice_clouds,rhowater,rhowaterice
       use aerosol_mod, only : iaero_h2o
-      Implicit none
-
-#include "callkeys.h"
-#include "dimensions.h"
-#include "dimphys.h"
-#include "tracer.h"
+      USE tracer_h
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
 #include "comcstfi.h"
 
-      real, intent(in) :: pq(ngridmx,nlayermx,nqmx) !tracer mixing ratios (kg/kg)
-      real, intent(in) :: pt(ngridmx,nlayermx)      !temperature (K)
-      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
-      real, intent(inout) :: nueffrad(ngridmx,nlayermx,naerkind) ! dispersion      
+      integer :: ngrid,nq
+
+      real, intent(in) :: pq(ngrid,nlayermx,nq) !tracer mixing ratios (kg/kg)
+      real, intent(in) :: pt(ngrid,nlayermx)      !temperature (K)
+      real, intent(inout) :: reffrad(ngrid,nlayermx,naerkind)      !aerosols radii (K)
+      real, intent(inout) :: nueffrad(ngrid,nlayermx,naerkind) ! dispersion      
 
       integer :: ig,l
@@ -151,5 +155,5 @@
       if (radfixed) then
          do l=1,nlayermx
-            do ig=1,ngridmx
+            do ig=1,ngrid
                zfice = 1.0 - (pt(ig,l)-T_h2O_ice_clouds) / (T_h2O_ice_liq-T_h2O_ice_clouds)
                zfice = MIN(MAX(zfice,0.0),1.0)
@@ -160,5 +164,5 @@
       else
          do l=1,nlayermx
-            do ig=1,ngridmx
+            do ig=1,ngrid
                zfice = 1.0 - (pt(ig,l)-T_h2O_ice_clouds) / (T_h2O_ice_liq-T_h2O_ice_clouds)
                zfice = MIN(MAX(zfice,0.0),1.0)
@@ -177,5 +181,5 @@
 
 !==================================================================
-   subroutine h2o_cloudrad(pql,reffliq,reffice)
+   subroutine h2o_cloudrad(ngrid,pql,reffliq,reffice)
 !==================================================================
 !     Purpose
@@ -189,14 +193,16 @@
 !==================================================================
       use watercommon_h, Only: rhowater,rhowaterice
-      Implicit none
-
-#include "callkeys.h"
-#include "dimensions.h"
-#include "dimphys.h"
-#include "tracer.h"
+      USE tracer_h
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
 #include "comcstfi.h"
 
-      real, intent(in) :: pql(ngridmx,nlayermx) !condensed water mixing ratios (kg/kg)
-      real, intent(out) :: reffliq(ngridmx,nlayermx),reffice(ngridmx,nlayermx)     !liquid and ice water particle radii (K)
+      integer :: ngrid
+
+      real, intent(in) :: pql(ngrid,nlayermx) !condensed water mixing ratios (kg/kg)
+      real, intent(out) :: reffliq(ngrid,nlayermx),reffice(ngrid,nlayermx)     !liquid and ice water particle radii (K)
 
       real,external :: CBRT            
@@ -204,11 +210,11 @@
 
       if (radfixed) then
-	 reffliq(1:ngridmx,1:nlayermx)= rad_h2o
-	 reffice(1:ngridmx,1:nlayermx)= rad_h2o_ice
+	 reffliq(1:ngrid,1:nlayermx)= rad_h2o
+	 reffice(1:ngrid,1:nlayermx)= rad_h2o_ice
       else
-	 reffliq(1:ngridmx,1:nlayermx)  = CBRT( 3*pql(1:ngridmx,1:nlayermx)/(4*Nmix_h2o*pi*rhowater) )
-	 reffliq(1:ngridmx,1:nlayermx)  = min(max(reffliq(1:ngridmx,1:nlayermx),1.e-6),100.e-6)
-	 reffice(1:ngridmx,1:nlayermx)  = CBRT( 3*pql(1:ngridmx,1:nlayermx)/(4*Nmix_h2o_ice*pi*rhowaterice) )
-	 reffice(1:ngridmx,1:nlayermx)  = min(max(reffice(1:ngridmx,1:nlayermx),1.e-6),100.e-6)
+	 reffliq(1:ngrid,1:nlayermx)  = CBRT( 3*pql(1:ngrid,1:nlayermx)/(4*Nmix_h2o*pi*rhowater) )
+	 reffliq(1:ngrid,1:nlayermx)  = min(max(reffliq(1:ngrid,1:nlayermx),1.e-6),100.e-6)
+	 reffice(1:ngrid,1:nlayermx)  = CBRT( 3*pql(1:ngrid,1:nlayermx)/(4*Nmix_h2o_ice*pi*rhowaterice) )
+	 reffice(1:ngrid,1:nlayermx)  = min(max(reffice(1:ngrid,1:nlayermx),1.e-6),100.e-6)
       end if
 
@@ -219,5 +225,5 @@
 
 !==================================================================
-   subroutine co2_reffrad(pq,reffrad)
+   subroutine co2_reffrad(ngrid,nq,pq,reffrad)
 !==================================================================
 !     Purpose
@@ -232,14 +238,16 @@
       use radinc_h, only: naerkind
       use aerosol_mod, only : iaero_co2
-      Implicit none
-
-#include "callkeys.h"
-#include "dimensions.h"
-#include "dimphys.h"
-#include "tracer.h"
+      USE tracer_h
+      Implicit none
+
+#include "callkeys.h"
+#include "dimensions.h"
+#include "dimphys.h"
 #include "comcstfi.h"
 
-      real, intent(in) :: pq(ngridmx,nlayermx,nqmx) !tracer mixing ratios (kg/kg)
-      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
+      integer :: ngrid,nq
+
+      real, intent(in) :: pq(ngrid,nlayermx,nq) !tracer mixing ratios (kg/kg)
+      real, intent(inout) :: reffrad(ngrid,nlayermx,naerkind)      !aerosols radii (K)
 
       integer :: ig,l
@@ -250,8 +258,8 @@
 
       if (radfixed) then
-         reffrad(1:ngridmx,1:nlayermx,iaero_co2) = 5.e-5 ! CO2 ice
+         reffrad(1:ngrid,1:nlayermx,iaero_co2) = 5.e-5 ! CO2 ice
       else
          do l=1,nlayermx
-            do ig=1,ngridmx
+            do ig=1,ngrid
                zrad = CBRT( 3*pq(ig,l,igcm_co2_ice)/(4*Nmix_co2*pi*rho_co2) )
                reffrad(ig,l,iaero_co2) = min(max(zrad,1.e-6),100.e-6)
@@ -266,5 +274,5 @@
 
 !==================================================================
-   subroutine dust_reffrad(reffrad)
+   subroutine dust_reffrad(ngrid,reffrad)
 !==================================================================
 !     Purpose
@@ -285,7 +293,9 @@
 #include "dimphys.h"
 
-      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
+      integer :: ngrid
+
+      real, intent(inout) :: reffrad(ngrid,nlayermx,naerkind)      !aerosols radii (K)
             
-      reffrad(1:ngridmx,1:nlayermx,iaero_dust) = 2.e-6 ! dust
+      reffrad(1:ngrid,1:nlayermx,iaero_dust) = 2.e-6 ! dust
 
    end subroutine dust_reffrad
@@ -294,5 +304,5 @@
 
 !==================================================================
-   subroutine h2so4_reffrad(reffrad)
+   subroutine h2so4_reffrad(ngrid,reffrad)
 !==================================================================
 !     Purpose
@@ -313,7 +323,9 @@
 #include "dimphys.h"
 
-      real, intent(inout) :: reffrad(ngridmx,nlayermx,naerkind)      !aerosols radii (K)
+      integer :: ngrid
+
+      real, intent(inout) :: reffrad(ngrid,nlayermx,naerkind)      !aerosols radii (K)
                 
-      reffrad(1:ngridmx,1:nlayermx,iaero_h2so4) = 1.e-6 ! h2so4
+      reffrad(1:ngrid,1:nlayermx,iaero_h2so4) = 1.e-6 ! h2so4
 
    end subroutine h2so4_reffrad
Index: trunk/LMDZ.GENERIC/libf/phystd/rain.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/rain.F90	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/rain.F90	(revision 787)
@@ -1,3 +1,3 @@
-subroutine rain(ptimestep,pplev,pplay,t,pdt,pq,pdq,d_t,dqrain,dqsrain,dqssnow,rneb)
+subroutine rain(ngrid,nq,ptimestep,pplev,pplay,t,pdt,pq,pdq,d_t,dqrain,dqsrain,dqssnow,rneb)
 
 
@@ -6,4 +6,5 @@
   use watercommon_h, only: T_h2O_ice_liq,T_h2O_ice_clouds, RLVTT, RCPD, RCPV, RV, RVTMP2,Psat_water,Tsat_water,rhowater
   use radii_mod, only: h2o_cloudrad
+  USE tracer_h
   implicit none
 
@@ -24,29 +25,30 @@
 #include "dimensions.h"
 #include "dimphys.h"
-#include "tracer.h"
 #include "comcstfi.h"
 #include "callkeys.h"
 
+      integer ngrid,nq
+
 !     Pre-arguments (for universal model)
-      real pq(ngridmx,nlayermx,nqmx)       ! tracer (kg/kg)
-      real qsurf(ngridmx,nqmx)             ! tracer at the surface (kg.m-2)
-      REAL pdt(ngridmx,nlayermx),pdq(ngridmx,nlayermx,nqmx)
-
-      real dqrain(ngridmx,nlayermx,nqmx)   ! tendency of H2O precipitation (kg/kg.s-1)
-      real dqsrain(ngridmx)                ! rain flux at the surface (kg.m-2.s-1)
-      real dqssnow(ngridmx)                ! snow flux at the surface (kg.m-2.s-1)
-      REAL d_t(ngridmx,nlayermx)           ! temperature increment
+      real pq(ngrid,nlayermx,nq)       ! tracer (kg/kg)
+      real qsurf(ngrid,nq)             ! tracer at the surface (kg.m-2)
+      REAL pdt(ngrid,nlayermx),pdq(ngrid,nlayermx,nq)
+
+      real dqrain(ngrid,nlayermx,nq)   ! tendency of H2O precipitation (kg/kg.s-1)
+      real dqsrain(ngrid)                ! rain flux at the surface (kg.m-2.s-1)
+      real dqssnow(ngrid)                ! snow flux at the surface (kg.m-2.s-1)
+      REAL d_t(ngrid,nlayermx)           ! temperature increment
 
 !     Arguments
       REAL ptimestep                    ! time interval
-      REAL pplev(ngridmx,nlayermx+1)    ! inter-layer pressure
-      REAL pplay(ngridmx,nlayermx)      ! mid-layer pressure
-      REAL t(ngridmx,nlayermx)          ! input temperature (K)
-      REAL zt(ngridmx,nlayermx)         ! working temperature (K)
-      REAL ql(ngridmx,nlayermx)         ! liquid water (Kg/Kg)
-      REAL q(ngridmx,nlayermx)          ! specific humidity (Kg/Kg)
-      REAL rneb(ngridmx,nlayermx)       ! cloud fraction
-      REAL d_q(ngridmx,nlayermx)        ! water vapor increment
-      REAL d_ql(ngridmx,nlayermx)       ! liquid water / ice increment
+      REAL pplev(ngrid,nlayermx+1)    ! inter-layer pressure
+      REAL pplay(ngrid,nlayermx)      ! mid-layer pressure
+      REAL t(ngrid,nlayermx)          ! input temperature (K)
+      REAL zt(ngrid,nlayermx)         ! working temperature (K)
+      REAL ql(ngrid,nlayermx)         ! liquid water (Kg/Kg)
+      REAL q(ngrid,nlayermx)          ! specific humidity (Kg/Kg)
+      REAL rneb(ngrid,nlayermx)       ! cloud fraction
+      REAL d_q(ngrid,nlayermx)        ! water vapor increment
+      REAL d_ql(ngrid,nlayermx)       ! liquid water / ice increment
 
 !     Subroutine options
@@ -78,17 +80,17 @@
 !     Local variables
       INTEGER i, k, n
-      REAL zqs(ngridmx,nlayermx),Tsat(ngridmx,nlayermx), zdelta, zcor
-      REAL zrfl(ngridmx), zrfln(ngridmx), zqev, zqevt
-
-      REAL zoliq(ngridmx)
-      REAL zdz(ngridmx),zrho(ngridmx),ztot(ngridmx), zrhol(ngridmx)
-      REAL zchau(ngridmx),zfroi(ngridmx),zfrac(ngridmx),zneb(ngridmx)
-
-      real reffh2oliq(ngridmx,nlayermx),reffh2oice(ngridmx,nlayermx)
+      REAL zqs(ngrid,nlayermx),Tsat(ngrid,nlayermx), zdelta, zcor
+      REAL zrfl(ngrid), zrfln(ngrid), zqev, zqevt
+
+      REAL zoliq(ngrid)
+      REAL zdz(ngrid),zrho(ngrid),ztot(ngrid), zrhol(ngrid)
+      REAL zchau(ngrid),zfroi(ngrid),zfrac(ngrid),zneb(ngrid)
+
+      real reffh2oliq(ngrid,nlayermx),reffh2oice(ngrid,nlayermx)
   
       real ttemp, ptemp, psat_tmp
-      real tnext(ngridmx,nlayermx)
-
-      real l2c(ngridmx,nlayermx)
+      real tnext(ngrid,nlayermx)
+
+      real l2c(ngrid,nlayermx)
       real dWtot
 
@@ -154,5 +156,5 @@
 !     GCM -----> subroutine variables
       DO k = 1, nlayermx
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
 
 	 zt(i,k)   = t(i,k)+pdt(i,k)*ptimestep ! a big fat bug was here
@@ -175,5 +177,5 @@
 !     Initialise the outputs
       DO k = 1, nlayermx
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          d_t(i,k) = 0.0
          d_q(i,k) = 0.0
@@ -181,5 +183,5 @@
       ENDDO
       ENDDO
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          zrfl(i)  = 0.0
          zrfln(i) = 0.0
@@ -188,5 +190,5 @@
       ! calculate saturation mixing ratio
       DO k = 1, nlayermx
-         DO i = 1, ngridmx
+         DO i = 1, ngrid
             ttemp = zt(i,k) 
             ptemp = pplay(i,k)
@@ -199,5 +201,5 @@
       ! get column / layer conversion factor
       DO k = 1, nlayermx
-         DO i = 1, ngridmx
+         DO i = 1, ngrid
             l2c(i,k)=(pplev(i,k)-pplev(i,k+1))/g
          ENDDO
@@ -211,5 +213,5 @@
 
          IF (evap_prec) THEN ! note no rneb dependence!
-            DO i = 1, ngridmx
+            DO i = 1, ngrid
                IF (zrfl(i) .GT.0.) THEN
 
@@ -241,5 +243,5 @@
          ENDIF
 
-         DO i = 1, ngridmx
+         DO i = 1, ngrid
             zoliq(i) = 0.0
          ENDDO
@@ -248,5 +250,5 @@
          if(precip_scheme.eq.1)then
 
-            DO i = 1, ngridmx
+            DO i = 1, ngrid
                ttemp = zt(i,k)
                IF (ttemp .ge. T_h2O_ice_liq) THEN
@@ -271,5 +273,5 @@
          elseif (precip_scheme.ge.2) then
           
-           DO i = 1, ngridmx
+           DO i = 1, ngrid
                IF (rneb(i,k).GT.0.0) THEN
                   zoliq(i) = ql(i,k)
@@ -284,5 +286,5 @@
 
  !recalculate liquid water particle radii
-	   call h2o_cloudrad(ql,reffh2oliq,reffh2oice)
+	   call h2o_cloudrad(ngrid,ql,reffh2oliq,reffh2oice)
 
            SELECT CASE(precip_scheme)
@@ -291,5 +293,5 @@
 
             DO n = 1, ninter
-               DO i = 1, ngridmx
+               DO i = 1, ngrid
                   IF (rneb(i,k).GT.0.0) THEN
                      ! this is the ONLY place where zneb, precip_timescale and cloud_sat are used
@@ -314,5 +316,5 @@
 	    
             DO n = 1, ninter
-               DO i = 1, ngridmx
+               DO i = 1, ngrid
                   IF (rneb(i,k).GT.0.0) THEN
                      ! this is the ONLY place where zneb, precip_timescale and cloud_sat are used
@@ -336,5 +338,5 @@
 
             DO n = 1, ninter
-               DO i = 1, ngridmx
+               DO i = 1, ngrid
                   IF (rneb(i,k).GT.0.0) THEN
                      ! this is the ONLY place where zneb and c1 are used
@@ -358,5 +360,5 @@
 
             ! Change in cloud density and surface H2O values
-            DO i = 1, ngridmx
+            DO i = 1, ngrid
                IF (rneb(i,k).GT.0.0) THEN
                   d_ql(i,k) = (zoliq(i) - ql(i,k))!/ptimestep
@@ -371,5 +373,5 @@
 
 !     Rain or snow on the ground
-      DO i = 1, ngridmx
+      DO i = 1, ngrid
          if(zrfl(i).lt.0.0)then
             print*,'Droplets of negative rain are falling...'
@@ -387,5 +389,5 @@
 !     now subroutine -----> GCM variables
       DO k = 1, nlayermx
-         DO i = 1, ngridmx
+         DO i = 1, ngrid
             
             if(evap_prec)then
Index: trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 787)
@@ -3,4 +3,9 @@
 ! to use  'getin'
       use ioipsl_getincom 
+      use surfdat_h
+      use comdiurn_h
+      use comsaison_h
+      use comsoil_h
+      USE comgeomfi_h
 
       implicit none
@@ -33,19 +38,11 @@
 #include "paramet.h"
 #include "dimphys.h"
-#include "comgeomfi.h"
-#include "surfdat.h"
-#include "comsoil.h"
-#include "comdiurn.h"
 #include "callkeys.h"
 #include "comcstfi.h"
 #include "planete.h"
-#include "comsaison.h"
 #include "control.h"
 #include "comvert.h"
 #include "netcdf.inc"
-#include "watercap.h" 
-#include "fisice.h"
 #include "logic.h"
-#include "advtrac.h"
 #include "comgeom.h"
 
@@ -95,5 +92,5 @@
       REAL tmp1(0:nlayermx),tmp2(0:nlayermx)
       Logical  tracerdyn
-      integer :: nq=1 ! number of tracers
+      integer :: nq !=1 ! number of tracers
  
       character*2 str2
@@ -110,11 +107,40 @@
 
 !     added by BC
-      REAL cloudfrac(ngridmx,nlayermx)
-      REAL hice(ngridmx),totcloudfrac(ngridmx)
+      REAL cloudfrac(1,nlayermx)
+      REAL hice(1),totcloudfrac(1)
       REAL qzero1D   !initial water amount on the ground
+
+!     added by AS to avoid the use of adv trac common
+      character*20 nametrac(nqmx)   ! name of the tracer (no need for adv trac common)
+
 
 c=======================================================================
 c INITIALISATION
 c=======================================================================
+
+      !! those are defined in surfdat_h.F90
+      IF (.not. ALLOCATED(albedodat)) ALLOCATE(albedodat(1))
+      IF (.not. ALLOCATED(phisfi)) ALLOCATE(phisfi(1))
+      IF (.not. ALLOCATED(zmea)) ALLOCATE(zmea(1))
+      IF (.not. ALLOCATED(zstd)) ALLOCATE(zstd(1))
+      IF (.not. ALLOCATED(zsig)) ALLOCATE(zsig(1))
+      IF (.not. ALLOCATED(zgam)) ALLOCATE(zgam(1))
+      IF (.not. ALLOCATED(zthe)) ALLOCATE(zthe(1))
+      IF (.not. ALLOCATED(dryness)) ALLOCATE(dryness(1))
+      IF (.not. ALLOCATED(watercaptag)) ALLOCATE(watercaptag(1))
+      !! those are defined in comdiurn_h.F90
+      IF (.not.ALLOCATED(sinlat)) ALLOCATE(sinlat(1))
+      IF (.not.ALLOCATED(coslat)) ALLOCATE(coslat(1))
+      IF (.not.ALLOCATED(sinlon)) ALLOCATE(sinlon(1))
+      IF (.not.ALLOCATED(coslon)) ALLOCATE(coslon(1))
+      !! those are defined in comsoil_h.F90
+      IF (.not.ALLOCATED(layer)) ALLOCATE(layer(nsoilmx))
+      IF (.not.ALLOCATED(mlayer)) ALLOCATE(mlayer(0:nsoilmx-1))
+      IF (.not.ALLOCATED(inertiedat)) ALLOCATE(inertiedat(1,nsoilmx))
+      !! those are defined in comgeomfi_h
+      IF (.not. ALLOCATED(lati)) ALLOCATE(lati(1))
+      IF (.not. ALLOCATED(long)) ALLOCATE(long(1))
+      IF (.not. ALLOCATED(area)) ALLOCATE(area(1))
+
 
       saveprofile=.false.
@@ -214,12 +240,7 @@
           endif
         
-          ! initialize advection schemes to Van-Leer for all tracers
-          do iq=1,nq
-            iadv(iq)=3 ! Van-Leer
-          enddo
-        
           do iq=1,nq
           ! minimal version, just read in the tracer names, 1 per line
-            read(90,*,iostat=ierr) tnom(iq)
+            read(90,*,iostat=ierr) nametrac(iq)
             if (ierr.ne.0) then
               write(*,*) 'rcm1d: error reading tracer names...'
@@ -232,9 +253,9 @@
          i_h2o_vap=0
          do iq=1,nq
-           if (tnom(iq)=="co2_ice") then
+           if (nametrac(iq)=="co2_ice") then
              i_co2_ice=iq
-           elseif (tnom(iq)=="h2o_ice") then
+           elseif (nametrac(iq)=="h2o_ice") then
              i_h2o_ice=iq
-           elseif (tnom(iq)=="h2o_vap") then
+           elseif (nametrac(iq)=="h2o_vap") then
              i_h2o_vap=iq
            endif
@@ -258,9 +279,9 @@
         do iq=1,nq
           write(str7,'(a1,i2.2)')'q',iq
-          tnom(iq)=str7
+          nametrac(iq)=str7
         enddo
         ! actually, we'll need at least one "co2_ice" tracer
         ! (for surface CO2 ice)
-        tnom(1)="co2_ice"
+        nametrac(1)="co2_ice"
         i_co2_ice=1
       endif ! of if (tracer)
@@ -482,5 +503,5 @@
 c    ---------------------------
 
-      DO iq=1,nqmx
+      DO iq=1,nq
         DO ilayer=1,nlayer
            q(ilayer,iq) = 0.
@@ -488,5 +509,5 @@
       ENDDO
      
-      DO iq=1,nqmx
+      DO iq=1,nq
         qsurf(iq) = 0.
       ENDDO
@@ -683,9 +704,9 @@
 c   les variables purement physiques a "physiq"...
 
-      call physdem1("startfi.nc",long,lati,nsoilmx,nqmx,
+      call physdem1(1,"startfi.nc",long,lati,nsoilmx,nq,
      &              dtphys,float(day0),
      &              time,tsurf,tsoil,emis,q2,qsurf,
      &              area,albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,
-     &              cloudfrac,totcloudfrac,hice)
+     &              cloudfrac,totcloudfrac,hice,nametrac)
 
 c=======================================================================
@@ -740,5 +761,6 @@
 
 
-      CALL physiq (1,llm,nqmx,
+      CALL physiq (1,llm,nq,
+     .     nametrac,
      ,     firstcall,lastcall,
      ,     day,time,dtphys,
@@ -802,5 +824,5 @@
 c       --------------------------------------
 
-        DO iq = 1, nqmx
+        DO iq = 1, nq
           DO ilayer=1,nlayer
              q(ilayer,iq)=q(ilayer,iq)+dtphys*dq(ilayer,iq)
Index: trunk/LMDZ.GENERIC/libf/phystd/soil.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 787)
@@ -1,6 +1,9 @@
-      subroutine soil(ngrid,nsoil,firstcall,
+      subroutine soil(ngrid,nsoil,firstcall,lastcall,
      &          therm_i,
      &          timestep,tsurf,tsoil,
      &          capcal,fluxgrd)
+
+      use comsoil_h
+
       implicit none
 
@@ -17,5 +20,4 @@
 #include "dimphys.h"
 
-#include"comsoil.h"
 
 c-----------------------------------------------------------------------
@@ -26,4 +28,5 @@
       integer nsoil	! number of soil layers 
       logical firstcall ! identifier for initialization call 
+      logical lastcall
       real therm_i(ngrid,nsoil) ! thermal inertia
       real timestep	    ! time step
@@ -35,22 +38,12 @@
 
 ! local saved variables:
-      !real,save :: mthermdiff(ngridmx,0:nsoilmx-1) ! mid-layer thermal diffusivity
-      !real,save :: thermdiff(ngridmx,nsoilmx-1) ! inter-layer thermal diffusivity
-      !real,save :: coefq(0:nsoilmx-1)		! q_{k+1/2} coefficients
-      !real,save :: coefd(ngridmx,nsoilmx-1)	! d_k coefficients
-      !real,save :: alph(ngridmx,nsoilmx-1)	! alpha_k coefficients
-      !real,save :: beta(ngridmx,nsoilmx-1)	! beta_k coefficients
-      !real,save :: mu
-
-      real mthermdiff(ngridmx,0:nsoilmx-1) ! mid-layer thermal diffusivity
-      real thermdiff(ngridmx,nsoilmx-1)    ! inter-layer thermal diffusivity
-      real coefq(0:nsoilmx-1)		   ! q_{k+1/2} coefficients
-      real coefd(ngridmx,nsoilmx-1)	   ! d_k coefficients
-      real alph(ngridmx,nsoilmx-1)	   ! alpha_k coefficients
-      real beta(ngridmx,nsoilmx-1)	   ! beta_k coefficients
-      real mu
+      real,dimension(:,:),save,allocatable :: mthermdiff ! mid-layer thermal diffusivity
+      real,dimension(:,:),save,allocatable :: thermdiff ! inter-layer thermal diffusivity
+      real,dimension(:),save,allocatable :: coefq ! q_{k+1/2} coefficients
+      real,dimension(:,:),save,allocatable :: coefd ! d_k coefficients
+      real,dimension(:,:),save,allocatable :: alph ! alpha_k coefficients
+      real,dimension(:,:),save,allocatable :: beta ! beta_k coefficients
+      real,save :: mu
             
-      save mthermdiff,thermdiff,coefq,coefd,alph,beta,mu
-
 ! local variables:
       integer ig,ik
@@ -64,4 +57,12 @@
       ! note: firstcall is set to .true. or .false. by the caller
       !       and not changed by soil.F 
+
+      ALLOCATE(mthermdiff(ngrid,0:nsoilmx-1)) ! mid-layer thermal diffusivity
+      ALLOCATE(thermdiff(ngrid,nsoilmx-1))    ! inter-layer thermal diffusivity
+      ALLOCATE(coefq(0:nsoilmx-1))              ! q_{k+1/2} coefficients
+      ALLOCATE(coefd(ngrid,nsoilmx-1))        ! d_k coefficients
+      ALLOCATE(alph(ngrid,nsoilmx-1))         ! alpha_k coefficients
+      ALLOCATE(beta(ngrid,nsoilmx-1))         ! beta_k coefficients
+
 ! 0.1 Build mthermdiff(:), the mid-layer thermal diffusivities
       do ig=1,ngrid
@@ -186,4 +187,12 @@
       enddo
 
+      if (lastcall) then
+        IF ( ALLOCATED(mthermdiff)) DEALLOCATE(mthermdiff)
+        IF ( ALLOCATED(thermdiff)) DEALLOCATE(thermdiff)
+        IF ( ALLOCATED(coefq)) DEALLOCATE(coefq)
+        IF ( ALLOCATED(coefd)) DEALLOCATE(coefd)
+        IF ( ALLOCATED(alph)) DEALLOCATE(alph)
+        IF ( ALLOCATED(beta)) DEALLOCATE(beta)
+      endif
 
       end
Index: trunk/LMDZ.GENERIC/libf/phystd/soil_settings.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/soil_settings.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/soil_settings.F	(revision 787)
@@ -1,3 +1,6 @@
       subroutine soil_settings(nid,ngrid,nsoil,tsurf,tsoil)
+
+      use comsoil_h
+
       implicit none
 
@@ -26,5 +29,4 @@
 #include "dimphys.h"
 
-#include "comsoil.h"
 #include "netcdf.inc"
 !======================================================================
@@ -35,7 +37,8 @@
       integer ngrid	! # of horizontal grid points
       integer nsoil	! # of soil layers
+      integer sta       ! # at which reading starts
       real tsurf(ngrid) ! surface temperature
 !  output:
-      real tsoil(ngridmx,nsoilmx)	! soil temperature
+      real tsoil(ngrid,nsoilmx)	! soil temperature
 
 !======================================================================
@@ -67,5 +70,19 @@
       real,parameter :: default_volcapa=1.e6
 
+      integer, dimension(2) :: sta2d
+      integer, dimension(2) :: siz2d
+
 !======================================================================
+
+      !! this is defined in comsoil_h
+      IF (.not.ALLOCATED(layer)) 
+     . ALLOCATE(layer(nsoilmx))
+      IF (.not.ALLOCATED(mlayer)) 
+     . ALLOCATE(mlayer(0:nsoilmx-1))
+      IF (.not.ALLOCATED(inertiedat)) 
+     . ALLOCATE(inertiedat(ngrid,nsoilmx))
+
+      !! this is defined in dimphys.h
+      sta = cursor
 
 ! 1. Depth coordinate
@@ -94,4 +111,8 @@
 	  interpol=.true.
 	endif
+
+      sta2d = (/sta,1/)
+      siz2d = (/ngrid,dimlen/)
+
 
 ! 1.2 Find out the # of dimensions <inertiedat> was defined as using
@@ -231,7 +252,7 @@
        allocate(surfinertia(ngrid))
 #ifdef NC_DOUBLE
-       ierr = NF_GET_VAR_DOUBLE(nid, nvarid, surfinertia)
-#else
-       ierr = NF_GET_VAR_REAL(nid, nvarid, surfinertia)
+       ierr = NF_GET_VARA_DOUBLE(nid, nvarid, sta, ngrid, surfinertia)
+#else
+       ierr = NF_GET_VARA_REAL(nid, nvarid, sta, ngrid, surfinertia)
 #endif
         if (ierr.NE.NF_NOERR) then
@@ -258,7 +279,7 @@
          endif
 #ifdef NC_DOUBLE
-        ierr = NF_GET_VAR_DOUBLE(nid,nvarid,oldinertiedat)
-#else
-        ierr = NF_GET_VAR_REAL(nid,nvarid,oldinertiedat)
+        ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,oldinertiedat)
+#else
+        ierr = NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,oldinertiedat)
 #endif
         if (ierr.NE.NF_NOERR) then
@@ -268,7 +289,7 @@
        else ! put values in therm_i
 #ifdef NC_DOUBLE
-        ierr = NF_GET_VAR_DOUBLE(nid,nvarid,inertiedat)
-#else
-        ierr = NF_GET_VAR_REAL(nid,nvarid,inertiedat)
+        ierr = NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,inertiedat)
+#else
+        ierr = NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,inertiedat)
 #endif
         if (ierr.NE.NF_NOERR) then
@@ -300,7 +321,7 @@
          endif
 #ifdef NC_DOUBLE
-        ierr=NF_GET_VAR_DOUBLE(nid,nvarid,oldtsoil)
-#else
-        ierr=NF_GET_VAR_REAL(nid,nvarid,oldtsoil)
+        ierr=NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,oldtsoil)
+#else
+        ierr=NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,oldtsoil)
 #endif
         if (ierr.ne.NF_NOERR) then
@@ -310,7 +331,7 @@
        else ! put values in tsoil
 #ifdef NC_DOUBLE
-        ierr=NF_GET_VAR_DOUBLE(nid,nvarid,tsoil)
-#else
-        ierr=NF_GET_VAR_REAL(nid,nvarid,tsoil)
+        ierr=NF_GET_VARA_DOUBLE(nid,nvarid,sta2d,siz2d,tsoil)
+#else
+        ierr=NF_GET_VARA_REAL(nid,nvarid,sta2d,siz2d,tsoil)
 #endif
         if (ierr.ne.NF_NOERR) then
Index: trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F	(revision 786)
+++ trunk/LMDZ.GENERIC/libf/phystd/surface_nature.F	(revision 787)
@@ -1,4 +1,10 @@
-      SUBROUTINE surface_nature(obliquit,qsurf,qsurfliquid
+      SUBROUTINE surface_nature(ngrid,nq,obliquit,qsurf,qsurfliquid
      &   ,qsurfsnow,rnat,oceanarea)
+
+      USE surfdat_h
+      USE comsoil_h
+      USE comgeomfi_h
+      USE tracer_h
+
       IMPLICIT none
 
@@ -31,19 +37,16 @@
 #include "comcstfi.h"
 #include "callkeys.h"
-#include "tracer.h"
-#include "fisice.h"
-#include "comgeomfi.h"
-#include "surfdat.h"
-#include "comsoil.h"
 
-	REAL qsurf(ngridmx,nqmx),ps(ngridmx)
-	REAL qsurfliquid(ngridmx)
-	REAL qsurfsnow(ngridmx)
+        integer ngrid,nq
+
+	REAL qsurf(ngrid,nq),ps(ngrid)
+	REAL qsurfliquid(ngrid)
+	REAL qsurfsnow(ngrid)
 	INTEGER iq, ig
-	INTEGER rnat(ngridmx)
+	INTEGER rnat(ngrid)
  	REAL oceanarea
 	REAL obliquit
 
-	do ig=1,ngridmx
+	do ig=1,ngrid
            rnat(ig)=1
            dryness(ig)=1        !(coefficient for evaporation)
@@ -56,5 +59,5 @@
         
         oceanarea=0.
-	do ig=1,ngridmx
+	do ig=1,ngrid
            if (rnat(ig).eq.0)then
               oceanarea=oceanarea+area(ig)
Index: trunk/LMDZ.GENERIC/libf/phystd/surfdat_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/surfdat_h.F90	(revision 787)
+++ trunk/LMDZ.GENERIC/libf/phystd/surfdat_h.F90	(revision 787)
@@ -0,0 +1,22 @@
+
+       module surfdat_h
+
+       implicit none
+
+       real,allocatable,dimension(:) :: albedodat ! albedo of bare ground
+       ! Ehouarn: moved inertiedat to comsoil.h
+       !      real inertiedat, ! thermal inertia
+       real,allocatable,dimension(:) :: phisfi ! geopotential at ground level
+       real,dimension(2) :: albedice
+       real,dimension(2) :: emisice ! ice emissivity; 1:Northern hemisphere 2:Southern hemisphere
+       real emissiv
+       real,dimension(2) :: iceradius, dtemisice
+       real,allocatable,dimension(:) :: zmea,zstd,zsig,zgam,zthe
+
+       real,allocatable,dimension(:) :: dryness  !"Dryness coefficient" for grnd water ice sublimation
+                                                 ! AS: previously in tracer.h. it is more logical here.
+
+       logical,allocatable,dimension(:) :: watercaptag !! was in watercap.h
+
+       end module surfdat_h
+
